<template>
    <div class='line-chart-wrapper'>
        <div class="line-chart_title">
            <h3>Отчёт по продажам за указанный период</h3>
        </div>
        <div class="line-chart_form">
            <form>
                <div class="form-group row">
                    <label class="col-md-2">Сотрудники</label>
                    <div class="col-md-6">
                        <select class="form-control" v-on:change="selectManager" v-model="selectedManager">
                            <option style="display: none" v-if="allManagers.length" value="null" disabled>Выберите сотрудника из списка</option>
                            <option style="display: none" v-else value="null" disabled>Выбраны все сотрудники</option>
                            <option v-for="manager in allManagers" :key="manager.id" v-bind:value="manager.id">{{ manager.managerName }}</option>
                        </select>
                    </div>
                    <div class="col-md-4 line-chart_selected-managers">
                        <button type="button" class="btn btn-info btn-sm" v-for="manager in filterData.selectedManagers" :key="manager.id" v-on:click="returnManagerInStack(manager.id)">
                            {{ manager.managerName }}
                        </button>
                        <button type="button" class="btn btn-info btn-sm" v-if="filterData.selectedManagers.length == 0">Выбраны все сотрудники</button>
                    </div>
                </div>
                <div class="form-group row">
                    <label class="col-md-2">Период</label>
                    <div class="col-md-3">
                        <input class="form-control" placeholder="От" type="date" v-model="filterData.date.from"/>
                    </div>
                    <div class="col-md-3">
                        <input class="form-control" placeholder="До" type="date" v-model="filterData.date.to"/>
                    </div>
                    <div class="col-md-4">
                        <button type="button" v-if="filterData.date.from" class="btn btn-info btn-sm" v-on:click="filterData.date.from = null">
                            C {{filterData.date.from}}
                        </button>
                        <button type="button" v-if="filterData.date.to" class="btn btn-info btn-sm" v-on:click="filterData.date.to = null">
                            По {{filterData.date.to}}
                        </button>
                    </div>
                </div>
                <div class="form-group row">
                    <label class="col-md-2">Интервал</label>
                    <div class="col-md-3">
                        <select class="form-control" v-model="filterData.value">
                            <option v-for="timestamp in timestampList" :key="timestamp.value" v-bind:value="timestamp.value">{{timestamp.label}}</option>
                        </select>
                    </div>
                    <div class="col-md-4">
                        <button type="button" v-if="filterData.value" class="btn btn-info btn-sm" v-on:click="filterData.value = null">
                            {{timestampList.find(x => x.value == filterData.value).label}}
                        </button>
                    </div>
                </div>
                <div class="form-group row">
                    <div class="col-md-9">
                        <button class="btn btn-primary" v-on:click.prevent="submitFilter">Сформировать</button>
                        <button class="btn btn-info" v-on:click.prevent="clearFilter">Очистить</button>
                    </div>
                </div>
            </form>
        </div>
        <div>
            <report-chart v-bind:datasets="datasets" v-bind:labels="labels"></report-chart>  
        </div>    
    </div>
</template>

<script>
    Array.prototype.pullOut = function(el) {
        let res = new Object;
        this.forEach((x, index) => {
            if(x.id == el) {

                res = Object.assign(res, x);
                this.splice(index, 1);
            }
        });
        return res;
    };

    import reportChart from './Charts/Reports'

    export default {
        name: 'SalesRepost',
        components: {
            reportChart
        },
        data: function() {
            return {
                labels: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
                datasets: [
                    {
                        label: 'Богданова',
                        backgroundColor: 'rgba(51,122,183,0.1)',
                        borderColor: 'rgb(51,122,183)',
                        data: [1, 1, 1, 1, 12, 40, 39, 80, 40, 20, 12, 11]
                    },
                    {
                        label: 'Сиротенко',
                        backgroundColor: 'rgba(183,51,54,0.1)',
                        borderColor: 'rgb(183,51,54)',
                        data: [12, 20, 12, 39, 10, 40, 39, 34, 40, 20, 66, 11]
                    },
                    {
                        label: 'Смирнов',
                        backgroundColor: 'rgba(54,191,172,0.1)',
                        borderColor: 'rgb(54,191,172)',
                        data: [6, 11, 43, 1, 10, 9, 12, 80, 40, 20, 12, 11]
                    }
                ],
                allManagers: [
                    {
                        id: 1,
                        managerName: "Сиротенко Сергей"
                    },
                    {
                        id: 2,
                        managerName: "Богданова Виктория"
                    },
                    {
                        id: 3,
                        managerName: "Смирнов Валерий"
                    }
                ],
                timestampList: [
                    {
                        value: 86400000,
                        label: 'сутки'
                    },
                    {
                        value: 604800000,
                        label: 'неделя'
                    },
                    {
                        value: 2592000000,
                        label: 'месяц'
                    }
                ],
                selectedManager: null,
                filterData: {
                    selectedManagers: [],
                    date: {
                        from: null,
                        to: null,
                    },
                    value: 86400000,
                }
            }
        },
        methods: {
            selectManager: function() {
                this.filterData.selectedManagers.push(this.allManagers.pullOut(this.selectedManager));
                this.selectedManager = null;
            },
            returnManagerInStack: function(managerId) {
                this.allManagers.push(this.filterData.selectedManagers.pullOut(managerId));
            },
            submitFilter: function() {

            },
            clearFilter: function() {
                this.filterData = {
                    selectedManagers: [],
                    date: {
                        from: null,
                        to: null,
                    },
                    value: 86400000,
                }
            }
        },
        mounted: function() {
            


        }
    }
</script>
<style>
    .line-chart_form {
        margin: 25px auto;
    }
    .line-chart_form label{
        font-weight: 400;
    }
    .btn {
        margin-left: 5px;
        margin-bottom: 5px;
    }
</style>